//
//  ViewController.m
//  iBeaconShoppingiFrogLab
//
//  Created by Powen Ko on 11/6/14.
//  Copyright (c) 2014 Powen Ko. All rights reserved.
//

#import "ViewController.h"
#import "Reachability.h"

@interface ViewController ()

@end

@implementation ViewController
@synthesize blockLabel,notificationLabel;
- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view, typically from a nib.
    self.title=@"iFrogLab iBeacon Shopping";
    // 藍芽初始化
    if(m_BT_BLE_Lib==nil){
        m_BT_BLE_Lib=[[BT_BLE_Lib alloc] init];     // 初始化
        m_BT_BLE_Lib.delegate=self;                 // 接收反應的class 指定為這個
    }
    
    int t_high=100;
    mUIWebView = [[UIWebView alloc] initWithFrame:CGRectMake(0, t_high,                  self.view.bounds.size.width ,
                self.view.bounds.size.height-t_high )];
    NSString *url=@"http://www.google.com";
    NSURL *nsurl=[NSURL URLWithString:url];
    //NSURLRequest *nsrequest=[NSURLRequest requestWithURL:nsurl];
    // [mUIWebView loadRequest:nsrequest];
    
    
    [self.view addSubview:mUIWebView];
    
    
    [m_BT_BLE_Lib iBeaconStartScan];
    [self ButtonSearchAgain:nil];
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


 // iBeacon 的情況
- (void) DidReceiveiBeacon:(NSString*)Name  RSSI:(NSNumber *)RSSI Action:(NSString*)Action                         // iBeacon 的情況
{
    NSLog(@"Discovered %@ at %@, Action=%@", Name, RSSI,Action);
    [self FunDispayItem:Name RSSI:RSSI Action:Action];
}
// iFrogLAB_BLE_Module


- (void) BlueToothStatus:(NSString*)errorMsg{}  // 取的HW 藍牙的連接情況
- (void) DidReceiveData:(NSString*)message{}    // 收到資料
- (void) DidReadHardwareRevisionString:(NSString*)Msg{} // 硬體相關的訊息
- (void) DigitalInputPinsChanges:(NSString*)Msg{}    // 數位輸入的情況改變
-(IBAction)ButtonSearchAgain:(id)sender{
    NSString *path = [[NSBundle mainBundle] bundlePath];
    NSURL *baseURL = [NSURL fileURLWithPath:path];
    [mUIWebView loadHTMLString:@"<img src=\"ibeacons-app-idea2.png\">" baseURL:baseURL];
    mUIWebView.delegate=self;
    
    [m_BT_BLE_Lib iBeaconStopScan];
    [m_BT_BLE_Lib iBeaconStartScan];
    
}
-(void)FunDispayItem:(NSString*)Name RSSI:(NSNumber *)RSSI Action:(NSString*)Action{
       if (RSSI.integerValue > -15) {
           return;
       }
    
       if (RSSI.integerValue < -50) {
           [m_BT_BLE_Lib iBeaconStopScan];
           NSLog(@"get it %@ at %@, Action=%@", Name, RSSI,Action);
           [self DisplayItem:Name];
       }
    

}
-(void) DisplayItem:(NSString*)Name{
    NSString* t_web=@"www.ifroglab.com";
   // if([Name isEqualToString:@"iFrogLAB_BLE_Module"]){
        t_web=@"http://www.powenko.com/shop/shop/%E5%82%B3%E6%84%9F%E5%99%A8/%E5%8F%B0%E7%81%A3%E8%A3%BD%E3%80%80ifrog-lab-%E8%97%8D%E8%8A%BD4-0-ble-%E6%A8%A1%E7%B5%84/";
   // }
    
    [[NSNotificationCenter defaultCenter] addObserver:self
                                             selector:@selector(reachabilityChanged:)
                                                 name:kReachabilityChangedNotification
                                               object:nil];
    
    Reachability * reach = [Reachability reachabilityWithHostname:@"www.google.com"];
    
    reach.reachableBlock = ^(Reachability * reachability)
    {
        dispatch_async(dispatch_get_main_queue(), ^{
            
            NSLog(@"Web Display %@", t_web);
            blockLabel.text = Name;
            
            loadedURL = t_web; //@"http://www.yahoo.com";
            NSURL *url = [NSURL URLWithString:loadedURL];
            NSURLRequest *requestObj = [NSURLRequest requestWithURL:url];
            [mUIWebView loadRequest:requestObj];
            
        });
    };
    
    reach.unreachableBlock = ^(Reachability * reachability)
    {
        dispatch_async(dispatch_get_main_queue(), ^{
            blockLabel.text = @"Internect not working.";
            NSString *path = [[NSBundle mainBundle] bundlePath];
            NSURL *baseURL = [NSURL fileURLWithPath:path];
            [mUIWebView loadHTMLString:@"<img src=\"ibeacon_sample.jpg\">" baseURL:baseURL];
            
        });
    };
    
    [reach startNotifier];
}

- (BOOL)webView:(UIWebView *)webView shouldStartLoadWithRequest:(NSURLRequest *)request navigationType:(UIWebViewNavigationType)navigationType{
    NSLog(@"Requesting: %@ - %@", request.URL.absoluteString, request.URL.host);
    if (navigationType != UIWebViewNavigationTypeOther) {
        //Store last selected URL
        notificationLabel.text = request.URL.absoluteString;
    }
    if (!isLoad && [request.URL.absoluteString isEqualToString:loadedURL]) {
        [NSURLConnection sendAsynchronousRequest:request queue:[NSOperationQueue mainQueue] completionHandler:^(NSURLResponse *response, NSData *data, NSError *connectionError) {
            if (connectionError || ([response respondsToSelector:@selector(statusCode)] && [((NSHTTPURLResponse *)response) statusCode] != 200 && [((NSHTTPURLResponse *)response) statusCode] != 302)) {
                blockLabel.text = @"Internect not working.";
            }else {
                isLoad = YES;
                [mUIWebView loadData:data MIMEType:[response MIMEType]
                 textEncodingName:[response textEncodingName]
                          baseURL:[response URL]];
            }
        }];
        return NO;
    }
    isLoad = NO;
    return YES;
}

-(void)reachabilityChanged:(NSNotification*)note
{
    Reachability * reach = [note object];
    
    if([reach isReachable])
    {
        notificationLabel.text = @"Notification Says Reachable";
    }
    else
    {
        notificationLabel.text = @"Notification Says Unreachable";
    }
}

@end
